<template>
  <div class="flex flex-col h-full">
    <PageHeader
      :loading="isLoading"
      @refresh="fetchData"
    />

    <Viewport>
      <section>
        <v-btn
          v-if="$route.query.fromBooking"
          prepend-icon="mdi-arrow-u-left-top"
          text="К бронированию"
          variant="text"
          class="text-teal-700"
          @click="$router.push(`/bookings/${$route.query.fromBooking}`)"
        />

        <v-btn
          v-else
          prepend-icon="mdi-arrow-u-left-top"
          text="К гостям"
          variant="text"
          class="text-teal-700"
          @click="$router.push('/guests')"
        />
      </section>

      <Feedback
        :message="feedback"
        class="mt-4"
        type="error"
      />

      <GuestsPageSkeleton v-if="isLoading || !guest" />

      <section
        v-if="!isLoading && guest"
        class="grid gap-4 xl:gap-6 grid-cols-1 xl:grid-cols-2 mt-4"
      >
        <section class="flex flex-col gap-4 xl:gap-6 items-start">
          <GuestCommonData
            :guest="guest"
            @update:common="onCommonDataUpdate"
          />

          <GuestPhonesList
            :phones="phones"
            @create:phone="onPhoneCreate"
            @delete:phone="onPhoneDelete"
          />

          <GuestNotesList
            :notes="notes"
            @create:note="onNoteCreate"
            @delete:note="onNoteDelete"
          />
        </section>

        <GuestLastBookings :guest="guest" />
      </section>
    </Viewport>
  </div>

  <v-overlay
    :model-value="isOverlayLoading"
    class="items-center justify-center"
    scrim="white"
    persistent
  >
    <v-progress-circular
      color="var(--tw-color-teal-600)"
      size="64"
      indeterminate
    />
  </v-overlay>
</template>

<script setup lang="ts">
import { onMounted, reactive, ref } from 'vue';
import { useRouter } from 'vue-router';

import { HttpClient } from '@/http';

import Viewport from '@/components/layout/Viewport.vue';
import PageHeader from '@/components/layout/PageHeader.vue';
import Feedback from '@/components/content/Feedback.vue';
import GuestsPageSkeleton from '@/components/skeletons/GuestsPageSkeleton.vue';

import GuestPhonesList from './page/phones/GuestPhonesList.vue';
import GuestNotesList from './page/notes/GuestNotesList.vue';
import GuestCommonData from './page/GuestCommonData.vue';
import GuestLastBookings from './page/GuestLastBookings.vue';

const router = useRouter();

const isLoading = ref(false);
const isOverlayLoading = ref(false);
const feedback = ref('');

const guest = ref<IGuest | null>(null);

const notes = reactive<IGuest['notes']>([]);
const phones = reactive<IGuest['phones']>([]);

const fetchData = async () => {
  isLoading.value = true;

  const id = router.currentRoute.value.params.id;
  const { data: { values, error } } = await HttpClient.get<IGuest>(`/v1/guests/${id}`);

  if (error) {
    feedback.value = error.message;
    return;
  }

  guest.value = values;

  notes.length = 0;
  notes.push(...guest.value!.notes);

  phones.length = 0;
  phones.push(...guest.value!.phones);

  isLoading.value = false;
};

const onCommonDataUpdate = async ({ name }: Pick<IGuest, 'name'>) => {
  isOverlayLoading.value = true;

  const { data: { error } } = await HttpClient.put(
    `/v1/guests/${guest.value!.id}`,
    { name },
  );

  if (!error) {
    guest.value!.name = name;
  }

  isOverlayLoading.value = false;
};

const onNoteCreate = async (note: IGuestNote['text']) => {
  isOverlayLoading.value = true;

  const { data: { values, error } } = await HttpClient.post(
    '/v1/guests/notes',
    { guestId: guest.value!.id, text: note },
  );

  if (!error) {
    notes.unshift(values);
  }

  isOverlayLoading.value = false;
};

const onNoteDelete = async (noteId: IGuestNote['id']) => {
  isOverlayLoading.value = true;

  const { data: { error } } = await HttpClient.delete(
    `/v1/guests/notes/${noteId}`,
  );

  if (!error) {
    const noteIndex = notes.findIndex(note => {
      return note.id === noteId;
    });

    notes.splice(noteIndex, 1);
  }

  isOverlayLoading.value = false;
};

const onPhoneCreate = async (
  { phone, force }: { phone: IGuestPhone['value'], force: boolean },
) => {
  isOverlayLoading.value = true;

  const { data: { values, error } } = await HttpClient.post(
    '/v1/guests/phones',
    { guestId: guest.value!.id, value: phone, force },
  );

  if (!error) {
    phones.unshift(values);
  }

  isOverlayLoading.value = false;
};

const onPhoneDelete = async (phoneId: IGuestPhone['id']) => {
  isOverlayLoading.value = true;

  const { data: { error } } = await HttpClient.delete(
    `/v1/guests/phones/${phoneId}`,
  );

  if (!error) {
    const phoneIndex = phones.findIndex(phone => {
      return phone.id === phoneId;
    });

    phones.splice(phoneIndex, 1);
  }

  isOverlayLoading.value = false;
};

onMounted(fetchData);
</script>